VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4320
   ClientLeft      =   3315
   ClientTop       =   1950
   ClientWidth     =   6765
   LinkTopic       =   "Form1"
   ScaleHeight     =   4320
   ScaleWidth      =   6765
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------
' TV Sample 6
'----------------

Public TV As New TrueVision
Public Screen As New Screen2D
Public Scene As New Scene3D
Public Maths As New Maths
Public Keyboard As New InputEngine
Public Effect As New SpecialEffects
Public Sound As New SoundEngine
Public Light As New LightEngine
Public Console As New Console


Dim Box(1000) As Mesh, Billboard
 Dim Mat As Integer
 Dim Tree(5) As Texture
 
 Dim Terrain As New Landscape
 
 Dim Water As Texture
 Dim TerrainTexture As Texture
 Dim Cloud As Mesh, Cloud2 As Mesh, CloudTexture As Texture
 Dim Voiture As Mesh
 
 Public StormSound As Integer, Strom As Single, WindSound As Integer
 
 Dim Waterfalls(15) As Texture, FallMat As Integer
 Dim Falls(20) As Mesh
 
 'Very important ! WithEvents in order to change the velocity and the lifetime
 'each time that a particle is created
 Dim WithEvents WaterBS As BillboardSystem
Attribute WaterBS.VB_VarHelpID = -1
 
 
Dim PosX As Single, PosY As Single, PosZ As Single
Dim Mus As Integer
Dim Fall As Integer
Dim LightSun As Integer, DarkLight As Integer
Dim CloudPos As D3DVECTOR, CloudKey





Sub ChangeCloudLight()
 CloudPos = Cloud.GetPosition
 If CloudPos.x > -120 And CloudPos.x < -50 Then
  Sound.StopBuffer Mus
  lit = (CloudPos.x + 50) / 100
  Light.SetLightAmbientColor LightSun, lit, lit, lit, 1
   Scene.SetSceneBackground 0.6 + (CloudPos.x + 50) * 0.3 / 70, 0.75 + (CloudPos.x + 50) * 0.4 / 70, 0.9 + (CloudPos.x + 50) * 0.5 / 70, 1

 End If
 If CloudPos.x > -350 And CloudPos.x < -80 Then
 
   If Rnd < 0.005 Then
    
    Sound.Play WindSound
   End If
   If Rnd < 0.01 Then
    Sound.Play StormSound, False
    Effect.InitFlash
    Effect.Flash 1, 1, 1
   End If
   If Effect.FlashFinish = False Then
    Effect.Flash 1, 1, 1
   End If
 End If
  If CloudPos.x > -300 Then
  Cloud.SetPosition CloudPos.x - TV.TimeElapsed * 0.01, CloudPos.y, CloudPos.z
  Cloud2.SetPosition Cloud2.GetPosition.x - TV.TimeElapsed * 0.01, Cloud2.GetPosition.y, Cloud2.GetPosition.z
  End If
End Sub

Sub CreateClouds()
  WriteLogConsole "Clouds creation..."
  Set Cloud = Scene.CreateMeshBuilder
  Cloud.AddVertex 0, 0, 1000, Maths.RGBA(1, 1, 1, 1), 1, 0.95, 0, -1, 0
  Cloud.AddVertex 0, 0, 0, Maths.RGBA(1, 1, 1, 1), 0, 0.95, 0, -1, 0
  Cloud.AddVertex 1000, 0, 1000, Maths.RGBA(1, 1, 1, 1), 1, 0, 0, -1, 0
  Cloud.AddVertex 1000, 0, 0, Maths.RGBA(1, 1, 1, 1), 0, 0, 0, -1, 0
  Set Cloud2 = Scene.CreateMeshBuilder
  Cloud2.AddVertex 0, 0, -5000, Maths.RGBA(0.1, 0.1, 0.2, 1), 1, 1, 0, -1, 0
  Cloud2.AddVertex 0, 0, 10000, Maths.RGBA(0.1, 0.1, 0.2, 1), 0, 1, 0, -1, 0
  Cloud2.AddVertex 0, 150, -5000, Maths.RGBA(0, 0.1, 0, 1), 1, 0, 0, -1, 0
  Cloud2.AddVertex 0, 150, 10000, Maths.RGBA(0, 0.1, 0, 1), 0, 0, 0, -1, 0


  Set CloudTexture = Scene.LoadTexture("terrain/clouds.bmp", 0, 0)
  Dim ddsd As DDSURFACEDESC2
  CloudTexture.GetSurface.GetSurfaceDesc ddsd
  CloudTexture.SetColorKey ddsd.ddpfPixelFormat.lBBitMask + ddsd.ddpfPixelFormat.lGBitMask + ddsd.ddpfPixelFormat.lRBitMask
  Cloud.ComputeSphere
  Cloud2.ComputeSphere
  Cloud.SetTexture CloudTexture
  Cloud.SetPosition 200, 150, -200
  Cloud2.SetPosition 1200, 0, -200
  Cloud.SetPrimitiveType TV_TRIANGLESTRIP
  Cloud.SetVertexType TV_LVERTEX
  
  Cloud2.SetPrimitiveType TV_TRIANGLESTRIP
  Cloud2.SetVertexType TV_LVERTEX
  
  Cloud.SetAlphaBlending True, D3DBLEND_SRCCOLOR, D3DBLEND_INVSRCALPHA
  WriteLogConsole "Clouds created"
End Sub


Sub CreateScene()
  
 WriteLogConsole "Pak Opening"
 TV.OpenPAKFile "textures.pak"
 Effect.InitSpecialEffects
 

 'DarkLight = Light.CreatePointLight(Maths.Vector(250, 30, 50), 50, -100, -100, -100, 1)
 LightSun = Light.CreateDirectionalLight(Maths.Vector(0, 1, 0), 1, 1, 1, 1)
 
  
 Dim TerrainMat As Integer
 TerrainMat = Light.CreateMaterial
 Light.SetMaterialAmbient TerrainMat, 1, 1, 1, 1
 'Light.SetMaterialEmissive TerrainMat, 0, 0, 0, 1
 Light.SetMaterialDiffuse TerrainMat, 0.8, 0.8, 0.8, 1
 
 WriteLogConsole "Texture loading"
 
 
 Terrain.CreateLandscape 1, 1, TV_LANDSCAPE_NORMAL
' Set Terrain = Scene.LoadTerrain("terrain/terrain.jpg", 16, 0.5, "Terrain")
 Set Water = Scene.LoadTexture("terrain/water.bmp")
 Set TerrainTexture = Scene.LoadTexture("terrain/texture3.jpg")
 Terrain.SetYAxisFactor 0.5
 Terrain.LoadTerrainPart "terrain/terrain.jpg", 0, 0
 Terrain.GenerateNormals
 Debug.Print "marche"
 'Terrain.SetVertexType TV_VERTEX
 'Terrain.SetTextureCoordinates 4, 4
 Terrain.SetWaterAltitude 20
 Terrain.SetWaterEnable True
 Terrain.SetWaterTexture Water
 Terrain.SetWaterTextureScale 32
 Terrain.SetWaterEffect True, 1, True
 Terrain.SetLandscapeMaterial TerrainMat
 Terrain.SetTerrainTexture 0, 0, TerrainTexture

 
 CreateClouds
 WriteLogConsole "Tree and water falls creating"
 For i = 1 To 4
   Set Tree(i) = Scene.LoadTexture("tree/tree" + CStr(i) + ".bmp", 256, 256)
   Tree(i).SetColorKey 0
 Next i
 
 For i = 1 To 15
  Set Waterfalls(i) = Scene.LoadTexture("smoke/zsmoke" + CStr(i) + ".bmp")
  Waterfalls(i).SetColorKey 0
 Next i

 Dim TreeMat As Integer
 TreeMat = Light.CreateMaterial
 Light.SetMaterialDiffuse TreeMat, 0.8, 0.8, 0.8, 1
 Light.SetMaterialAmbient TreeMat, 1, 1, 1, 1
 For i = 1 To 100
ret:
   x = Rnd * 256
   z = Rnd * 256
   If Terrain.GetHeight(x, z) < 30 Or Terrain.GetHeight(x, z) > 50 Then GoTo ret
   Set Box(i) = Scene.CreateBillboard(Tree(Int(Rnd * 4) + 1), x, Terrain.GetHeight(x, z) + 10, z, 10, 20, False, 0, 0)
   Box(i).SetVertexType TV_VERTEX
   Box(i).SetMaterial TreeMat
   Box(i).ComputeSphere
   Box(i).SetAlphaBlending False
 Next
 
 
 Set WaterBS = Effect.InitBillboardParticleSystem(100, 0, 10, Vector(206, 100, 20), 10, Waterfalls(Int(Rnd * 15) + 1))
  WaterBS.SetAlphaBlendingMode TV_CHANGE_COLOR, D3DBLEND_ONE, D3DBLEND_ONE
 
 For i = 1 To 100
   WaterBS.SetParticleLifeTime 5, i
   WaterBS.SetParticleDirection Maths.Vector(-0.5, -1, 0.5), CLng(i)
   WaterBS.SetParticleTexture Waterfalls((i Mod 15) + 1), CLng(i)
   WaterBS.SetParticleColor 0.1, 0.1, 0.1, 0.5, CLng(i)
  Next i
 
 WaterBS.SetParticleSpeed 0.02
 WaterBS.SetGeneratorSpeed 60  '1 new particle every 60ms
 
 WaterBS.SetGravity 9.87 / 10, 0.1
 
 
 FallMat = Light.CreateMaterial
 Light.SetMaterialAmbient FallMat, 0.1, 0.1, 0.1, 0.1

 Scene.SetSceneBackground 0.6, 0.75, 0.9, 1
' Effect.SetSceneFog 0.6, 0.75, 0.9, 0.05
 
'sound loading
Sound.InitDirectSound
WriteLogConsole "Loading sound"

Fall = Sound.LoadWave("fall.wav", True)
Mus = Sound.LoadWave("mus.wav", True)
StormSound = Sound.LoadWave("storm.wav", True)
WindSound = Sound.LoadWave("wind.wav", True)

Sound.Play Fall, True
Sound.Play Mus, True


Debug.Print "project"; 1
 TV.ClosePAKFile

End Sub





Private Sub Form_Load()
 Dim ScrWidth As Long, ScrHeight As Long
 
 ScrWidth = 500
 ScrHeight = 500
 TV.ShowDriverWindow
 TV.InitCurrentVideoMode
' TV.Init3DFullScreen ScrWidth, ScrHeight, 16
 'TV.Init3DWindowedMode Form1.hWnd
 TV.DisplayFPS = True
 
 Console.InitConsole TV_FULLSCREEN
 
 On Error GoTo re
 
 
 TV.SetSearchDirectory App.Path
 
 
 DoEvents
 WriteLogConsole "Scene loading..."
CreateScene
Scene.SetViewFrustum 10000, 90

PosX = 100: PosZ = 100
 
 Do
  TV.Clear
  num = 0
  
  'render all the VISIBLE trees and count the number of VISIBLE trees
  Scene.RenderAllMeshes
  'render the terrain

  
  'display flashs and change lights
  ChangeCloudLight
  
  'render "clouds"
 ' Cloud.RenderMesh
 ' Cloud2.RenderMesh
 
  Terrain.RenderLandscape
  WaterBS.RenderBillboardSystem
  
  WaterBS.UpdateParticles TV_UPDATE_BOUNCE_ON_LANDSCAPE Or TV_UPDATE_GENERATOR
  
  'set the new camera
  Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(ang), PosY + Sin(AngY), PosZ + Sin(ang)
  
  DoEvents
  
  'flip all to the screen
  TV.RenderToScreen
  
  'keyboard input
   If Keyboard.KeyPressed(vbKeyLeft) = True Then
    ang = ang + TV.TimeElapsed * 0.005
  End If
  If Keyboard.KeyPressed(vbKeyRight) = True Then
    ang = ang - TV.TimeElapsed * 0.005
  End If
  
  ancx = PosX
  ancz = PosZ
  
  
  If Keyboard.KeyPressed(vbKeyUp) = True Then
    PosX = PosX + Cos(ang) * TV.TimeElapsed * (0.03 + Run * 0.04)
    PosZ = PosZ + Sin(ang) * TV.TimeElapsed * (0.03 + Run * 0.04)
    h = 1
  End If
  If Keyboard.KeyPressed(vbKeyDown) = True Then
    PosX = PosX - (Cos(ang) * TV.TimeElapsed * (0.03 + Run * 0.02))
    PosZ = PosZ - (Sin(ang) * TV.TimeElapsed * (0.03 + Run * 0.02))
    h = -1
  End If
  If Keyboard.GetMouseButton = 2 Then Run = 1 Else Run = 0
  
  'get the new "altitude" for the player
  PosY = Terrain.GetHeight(PosX, PosZ) + 10
   
   'don't go at altitude +50 and less 30
   If PosY < 30 Or PosY > 50 Then
    'PosX = ancx
    'PosZ = ancz
   End If
    
    c = 0
'IF there's a bigger change than 1 pixels, change horizontal angle... modify the 1 for sensitivity settings...
  If (Keyboard.GetMouseX - PrevMouseX) < -1 Or (Keyboard.GetMouseX - PrevMouseX) > 1 Then
  ang = ang + TV.TimeElapsed * (PrevMouseX - Keyboard.GetMouseX) / 1000
  PrevMouseX = ScrWidth / 2
  c = 1
  End If

'IF there's a bigger change than 1 pixels, change vertical angle... modify the 1 for sensitivity settings...
  If (Keyboard.GetMouseY - PrevMouseY) < -1 Or (Keyboard.GetMouseY - PrevMouseY) > 1 Then
  AngY = AngY + TV.TimeElapsed * (PrevMouseY - Keyboard.GetMouseY) / 1000
  If Abs(AngY) > 1.52 Then AngY = Sgn(AngY) * 1.52
  PrevMouseY = ScrHeight / 2
  c = 1
  End If
  If c = 1 Then Keyboard.SetMousePosition Int(ScrWidth / 2), Int(ScrHeight / 2)
  
  Sound.SetListenerPosition PosX, PosY, PosZ
  Sound.SetListenerOrientation Cos(ang), Cos(angz), Sin(ang), 0, 1, 0
 
 Sound.SetPosition Mus, PosX, PosY, PosZ
 Sound.SetPosition Fall, PosX, PosY, PosZ
 Sound.SetPosition StormSound, PosX, PosY, PosZ
 Sound.SetPosition WindSound, PosX, PosY, PosZ
 Loop Until Keyboard.KeyPressed(vbKeyEscape) = True
 End

re:
Debug.Print "Err: "; Err.Description, " "; Err.Number

End
End Sub
Sub WriteLogConsole(Text As String, Optional ConsoleVisible = True)
  Console.WriteConsole Text
  Console.RenderConsole
  TV.RenderToScreen
End Sub

Private Sub WaterBS_NewParticle(VelocX As Variant, VelocY As Variant, VelocZ As Variant, ColorR As Variant, ColorG As Variant, ColorB As Variant, ColorA As Variant, LifeTime As Variant, TextureIndex As Variant)
   Randomize Timer
   VelocX = -0.5 + Rnd * 0.2
   VelocY = 0.2
   VelocZ = 0.5 + Rnd * 0.2
   LifeTime = 5
End Sub


